
;the following are from Innards.asm and represents memory management

externdef Initialize:near							;Initializes all the globals void					Initialize(void);
externdef GetMem64:near								;Gets memory dynaimcally							MYWORDPTR GetMem64(MYWORD _size);
externdef Free64:near								;frees dynamically allocated memory					void Free64(MYWORDPTR _val);
externdef InitVals:near

;the following are from Asm64.asm and represents the algorithms that work on the arrays

externdef AAnd64:near								;ands 2 arrays together								MYWORDPTR AAnd64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AOr64:near								;Ors 2 arrays together								MYWORDPTR AOr64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AXor64:near								;XOrs 2 arrays together								MYWORDPTR AXor64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AAdd64:near								;adds 2 arrays together								MYWORDPTR AAdd64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef ASub64:near								;Subtracts one array from another					MYWORDPTR ASub64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AMultiply64:near							;multiplies 2 arrays together						MYWORDPTR AMultiply64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef ASquare64:near							;squares an array									MYWORDPTR ASquare64(MYWORDPTR _val);
externdef ADivide64:near							;divides one array from another						MYWORDPTR ADivide64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AMod64:near								;modular reduction of an array						MYWORDPTR AMod64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef APow64:near								;exponentiation of an array							MYWORDPTR APow64(MYWORDPTR _base, MYWORDPTR _exponent);
externdef AModPow64:near							;modular exponentiation of an array					MYWORDPTR AModPow64(MYWORDPTR _base, MYWORDPTR _exponent, MYWORDPTR _modulus);
externdef AE64:near									;checks for equality between 2 arrays				MYWORD AE64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef ANE64:near								;checks for inequality between 2 arrays				MYWORD ANE64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef ALT64:near								;less than											MYWORD ALT64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef ALTOE64:near								;less than or equal									MYWORD ALTOE64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AGT64:near								;greater than										MYWORD AGT64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AGTOE64:near								;greater than or equal								MYWORD AGTOE64(MYWORDPTR _val1, MYWORDPTR _val2);
externdef AToString64:near							;produces the string value of an array				char* AToString64(MYWORDPTR _val, MYWORD _radix);
externdef ACountDigits:near							;counts the digits w/o creating string				MYWORD CountDigits(MYWORDPTR _val, MYWORD _radix);
externdef ADivBitShiftLeft64:near
externdef ADivMult64:near
externdef ADivSub64:near
externdef ADivBitShiftRight64:near
externdef ADivByteShiftLeft64:near
externdef ADivByteShiftRight64:near
externdef ADivRem64:near

;these are the basic math definitions for the ABI class found in BIAsm64 CBI* is the class name in native c++ ABI is its equivalent in Assembly and managed c++

;ABI==Big Integer for all integer values

externdef CreateBI:near								;Creates a new instance of ABI						CBI* CreateBI();
externdef CreateBICopy:near							;Creates a new instance of ABI from an array			CBI* CreateBICopy(MYWORDPTR _val1);
externdef CreateBITake:near							;Creates a new instance of ABI from an array			CBI* CreateBITake(MYWORDPTR _val1);
externdef CreateBIFromBI:near						;Creates a new instance of ABI from a ABI object		CBI* CreateBIFromBI(CBI* _val1);
externdef CreateBICopyWithSign:near					;Creates a new instance of ABI from an array			CBI* CreateBICopyWithSign(MYWORDPTR _val1, MYWORD _val2);
externdef DestroyBI:near							;Destroys a ABI instance								void DestroyBI(CBI* _val);
externdef BIE64:near								;checks for equality								MYWORD BIE64(CBI* _val1, CBI* _val2);
externdef BINE64:near								;checks for inequality								MYWORD BINE64(CBI* _val1, CBI* _val2);
externdef BILT64:near								;less than											MYWORD BILT64(CBI* _val1, CBI* _val2);
externdef BILTOE64:near								;less than or equal									MYWORD BILTOE64(CBI* _val1, CBI* _val2);
externdef BIGT64:near								;greater than										MYWORD BIGT64(CBI* _val1, CBI* _val2);
externdef BIGTOE64:near								;greater than or equal								MYWORD BIGTOE64(CBI* _val1, CBI* _val2);
externdef BIAdd64:near								;adds 2 ABI values together							CBI* BIAdd64(CBI* _val1, CBI* _val2);
externdef BISub64:near								;subtracts 2 ABI values								CBI* BISub64(CBI* _val1, CBI* _val2);
externdef BIMultiply64:near							;multiplies 2 ABI values together					CBI* BIMultiply64(CBI* _val1, CBI* _val2);
externdef BIDivide64:near							;divides 2 ABI values								CBI* BIDivide64(CBI* _val1, CBI* _val2);
externdef BIMod64:near								;modular reduction of a ABI value					CBI* BIMod64(CBI* _val1, CBI* _val2);
externdef BIPow64:near								;exponentiation of a ABI value						CBI* BIPow64(CBI* _base, CBI* _exponent);
externdef BIModPow64:near							;modular exponentiation of a ABI value				CBI* BIModPow64(CBI* _base, CBI* _exponent, CBI* _modulus);
externdef BIToString:near							;produces the string value of a ABI					char* BIToString(CBI* _val, MYWORD _radix);

;these are the basic math definitions for the ABD class found in BIAsm64 CBD* is the class name in native c++ ABD is its equivalent in Assembly and managed c++

;ABD==Big Decimal for all values (includes all integer values)

externdef CreateBD:near								;Creates a new instance of ABD						CBD* CreateBD();
externdef CreateBDCopy:near							;Creates a new instance of ABD from an array			CBD* CreateBDCopy(MYWORDPTR _val1);
externdef CreateBDTake:near							;Creates a new instance of ABD from an array			CBD* CreateBDTake(MYWORDPTR _val1);
externdef CreateBDFromBD:near						;Creates a new instance of ABD from a ABD object		CBD* CreateBDFromBD(CBD* _val1);
externdef DestroyBD:near							;Destroys a ABD instance								void DestroyBD(CBD* _val);
externdef BDE64:near								;checks for equality								MYWORD BDE64(CBD* _val1, CBD* _val2);
externdef BDNE64:near								;checks for inequality								MYWORD BDNE64(CBD* _val1, CBD* _val2);
externdef BDLT64:near								;less than											MYWORD BDLT64(CBD* _val1, CBD* _val2);
externdef BDLTOE64:near								;less than or equal									MYWORD BDLTOE64(CBD* _val1, CBD* _val2);
externdef BDGT64:near								;greater than										MYWORD BDGT64(CBD* _val1, CBD* _val2);
externdef BDGTOE64:near								;greater than or equal								MYWORD BDGTOE64(CBD* _val1, CBD* _val2);
externdef BDAdd64:near								;Adds 2 ABD values together							CBD* BDAdd64(CBD* _val1, CBD* _val2);
externdef BDSub64:near								;subtracts 2 ABD values								CBD* BDSub64(CBD* _val1, CBD* _val2);
externdef BDMultiply64:near							;multiplies 2 ABD values								CBD* BDMultiply64(CBD* _val1, CBD* _val2);
externdef BDDivide64:near							;divides 2 ABD values								CBD* BDDivide64(CBD* _val1, CBD* _val2);
externdef BDMod64:near								;modular reduction of a ABD value					CBD* BDMod64(CBD* _val1, CBD* _val2);
externdef BDPow64:near								;exponentiation of a ABD value						CBD* BDPow64(CBD* _base, CBD* _exponent);
externdef BDModPow64:near							;modular exponentiation of a ABD value				CBD* BDModPow64(CBD* _base, CBD* _exponent, CBD* _modulus);
externdef BDToString:near							;produces the string value of ABD					char* BDToString64(CBD* _val, MYWORD _radix);

;these are the basic math definitions for the ABF class found in BIAsm64 CBF* is the class name in native c++ ABF is its equivalent in Assembly and managed c++

;ABF==Big Fraction for all values (includes all integer values)

externdef CreateBF:near								;Creates a new instance of ABF						CBF* CreateBF();
externdef CreateBFCopy:near							;Creates a new instance of ABF from an array			CBF* CreateBFCopy(MYWORDPTR _num);
externdef CreateBFCopyBoth:near						;Creates a new instance of ABF from two arrays		CBF* CreateBFCopyBoth(MYWORDPTR _num, MYWORDPTR _den);
externdef CreateBFTake:near							;Creates a new instance of ABF from an array			CBF* CreateBFTake(MYWORDPTR _num);
externdef CreateBFTakeBoth:near						;Creates a new instance of ABF from two arrays		CBF* CreateBFTakeBoth(MYWORDPTR _num, MYWORDPTR _den);
externdef CreateBFFromBF:near						;Creates a new instance of ABF from a ABF object		CBF* CreateBFFromBF(CBF* _val1);
externdef DestroyBF:near							;Destroys a ABF instance								void DestroyBF(CBF* _val);
externdef BFTakeNewNumerator:near					;Takes possession of an array for the numerator		CBF* CreateBFFromBF(CBF* _val1);
externdef BFTakeNewDenominator:near					;Takes possession of an array for the denominator	void DestroyBF(CBF* _val);
externdef BFE64:near								;checks equality									MYWORD BFE64(CBF* _val1, CBF* _val2);
externdef BFNE64:near								;checks for inequality								MYWORD BFNE64(CBF* _val1, CBF* _val2);
externdef BFLT64:near								;less than											MYWORD BFLT64(CBF* _val1, CBF* _val2);
externdef BFLTOE64:near								;less than or equal									MYWORD BFLTOE64(CBF* _val1, CBF* _val2);
externdef BFGT64:near								;greater than										MYWORD BFGT64(CBF* _val1, CBF* _val2);
externdef BFGTOE64:near								;greater than or equal								MYWORD BFGTOE64(CBF* _val1, CBF* _val2);
externdef BFAdd64:near								;adds 2 ABF values									CBF* BFAdd64(CBF* _val1, CBF* _val2);
externdef BFSub64:near								;subtracts 2 ABF values								CBF* BFSub64(CBF* _val1, CBF* _val2);
externdef BFMultiply64:near							;multiplies 2 ABF values								CBF* BFMultiply64(CBF* _val1, CBF* _val2);
externdef BFDivide64:near							;divides 2 ABF values								CBF* BFDivide64(CBF* _val1, CBF* _val2);
externdef BFMod64:near								;modular reduction of a ABF value					CBF* BFMod64(CBF* _val1, CBF* _val2);
externdef BFPow64:near								;exponentiation of a ABF value						CBF* BFPow64(CBF* _base, CBF* _exponent);
externdef BFModPow64:near							;modular exponentiation of a ABF value				CBF* BFModPow64(CBF* _base, CBF* _exponent, CBF* _modulus);
externdef BFToString:near							;produces the string value of ABF					char* BFToString(CBF* _val, MYWORD _radix);

;these are the basic math definitions for the ABDI class found in BIAsm64 CBDI* is the class name in native c++ ABDI is its equivalent in Assembly and managed c++

;ABDI==Big Decimal Complex for all values (including all real values)

externdef CreateBDI:near							;Creates a new instance of ABDI						CBDI* CreateBDI();
externdef CreateBDICopyBD:near						;Creates a new instance of ABDI from a ABD object		CBDI* CreateBDICopyBD(ABD* _r);
externdef CreateBDICopyArray:near					;Creates a new instance of ABDI from an array		CBDI* CreateBDICopyArray(MYWORDPTR _r);
externdef CreateBDICopyBothBD:near					;Creates a new instance of ABDI from two ABD objects	CBDI* CreateBDICopyBothBD(ABD* _r, ABD* _i);
externdef CreateBDICopyBothArray:near				;Creates a new instance of ABDI from two arrays		CBDI* CreateBDICopyBothArray(MYWORDPTR _r, MYWORDPTR _i);
externdef CreateBDITakeBD:near						;Creates a new instance of ABDI from a ABD object		CBDI* CreateBDITakeBD(ABD* _r);
externdef CreateBDITakeArray:near					;Creates a new instance of ABDI from an array		CBDI* CreateBDITakeArray(MYWORDPTR _r);
externdef CreateBDITakeBothBD:near					;Creates a new instance of ABDI from two ABD objects	CBDI* CreateBDITakeBothBD(ABD* _r, ABD* _i);
externdef CreateBDITakeBothArray:near				;Creates a new instance of ABDI from two arrays		CBDI* CreateBDITakeBothArray(MYWORDPTR _r, MYWORDPTR _i);
externdef CreateBDIFromBDI:near						;Creates a new instance of ABDI from a ABDI object	CBDI* CreateBDIFromBDI(CBDI* _val1);
externdef DestroyBDI:near							;Destroys a ABDI instance							void DestroyBDI(CBDI* _val);
externdef BDIConjugate:near							;produces the conjugate of a ABDI value				CBDI* BDIConjugate(CBDI* _val);
externdef BDIToPolar:near							;changes a ABDI value to polar form					CBDI* BDIToPolar(CBDI* _val);
externdef BDIFromPolar:near							;changes a ABDI polar form back						CBDI* BDIFromPolar(CBDI* _val);
externdef BDIE64:near								;checks equality									MYWORD BDIE64(CBDI* _val1, CBDI* _val2);
externdef BDINE64:near								;checks for inequality								MYWORD BDINE64(CBDI* _val1, CBDI* _val2);
externdef BDIAdd64:near								;adds 2 ABDI values									CBDI* BDIAdd64(CBDI* _val1, CBDI* _val2);
externdef BDISub64:near								;subtracts 2 ABDI values								CBDI* BDISub64(CBDI* _val1, CBDI* _val2);
externdef BDIMultiply64:near						;multiplies 2 ABDI values							CBDI* BDIMultiply64(CBDI* _val1, CBDI* _val2);
externdef BDISquare64:near							;squares a ABDI value								CBDI* BDISquare64(CBDI* _val);
externdef BDIDivide64:near							;divides 2 ABDI values								CBDI* BDIDivide64(CBDI* _val1, CBDI* _val2);
externdef BDIPow64:near								;exponentiation of a ABDI value						CBDI* BDIPow64(CBDI* _base, CBDI* _exponent);
externdef BDIToString:near							;produces string value of ABDI						char* BDIToString(CBDI* _val, MYWORD _radix);

;these are the basic math definitions for the ABFI class found in BIAsm64 CBFI* is the class name in native c++ ABFI is its equivalent in Assembly and managed c++

;ABFI==Big Fraction Complex for all values (including all real values)

externdef CreateBFI:near							;Creates a new instance of ABFI						CBFI* CreateBFI();
externdef CreateBFICopyBF:near						;Creates a new instance of ABFI from a ABF object		CBFI* CreateBFICopyBF(ABF* _r);
externdef CreateBFICopyArray:near					;Creates a new instance of ABFI from an array		CBFI* CreateBFICopyArray(MYWORDPTR _r);
externdef CreateBFICopyBothBF:near					;Creates a new instance of ABFI from two ABF objects	CBFI* CreateBFICopyBothBF(ABF* _r, ABF* _i);
externdef CreateBFICopyBothArray:near				;Creates a new instance of ABFI from two arrays		CBFI* CreateBFICopyBothArray(MYWORDPTR _r, MYWORDPTR _i);
externdef CreateBFITakeBF:near						;Creates a new instance of ABFI from a ABF object		CBFI* CreateBFITakeBF(ABF* _r);
externdef CreateBFITakeArray:near					;Creates a new instance of ABFI from an array		CBFI* CreateBFITakeArray(MYWORDPTR _r);
externdef CreateBFITakeBothBF:near					;Creates a new instance of ABFI from two ABF objects	CBFI* CreateBFITakeBothBF(ABF* _r, ABF* _i);
externdef CreateBFITakeBothArray:near				;Creates a new instance of ABFI from two arrays		CBDI* CreateBFITakeBothArray(MYWORDPTR _r, MYWORDPTR _i);
externdef CreateBFIFromBFI:near						;Creates a new instance of ABFI from a ABFI object	CBDI* CreateBFIFromBFI(CBFI* _val1);
externdef DestroyBFI:near							;Destroys a ABFI instance							void DestroyBFI(CBFI* _val);
externdef BFIConjugate:near							;produces the conjugate of a ABFI value				CBFI* BFIConjugate(CBFI* _val);
externdef BFIToPolar:near						;changes a ABFI to polar form							CBFI* BFIToPolarForm(CBFI* _val);
externdef BFIFromPolar:near							;changes a polar form back							CBFI* BFIFromPolar(CBFI* _val);
externdef BFIE64:near								;checks for equality								MYWORD BFIE64(CBFI* _val1, CBFI* _val2);
externdef BFINE64:near								;checks for inequality								MYWORD BFINE64(CBFI* _val1, CBFI* _val2);
externdef BFIAdd64:near								;adds 2 ABFI values									CBFI* BFIAdd64(CBFI* _val1, CBFI* _val2);
externdef BFISub64:near								;subtracts 2 ABFI values								CBFI* BFISub64(CBFI* _val1, CBFI* _val2);
externdef BFIMultiply64:near						;multiplies 2 ABFI values							CBFI* BFIMultiply64(CBFI* _val1, CBFI* _val2);
externdef BFISquare:near							;squares a ABFI value								CBFI* BFISquare64(CBFI* _val);
externdef BFIDivide64:near							;divides 2 ABFI values								CBFI* BFIDivide64(CBFI* _val1, CBFI* _val2);
externdef BFIPow64:near								;exponentiation of a ABFI value						CBFI* BFIPow64(CBFI* _base, CBFI* _exponent);
externdef BFIToString:near							;produces string value of ABFI						char* BFIToString(CBFI* _val, MYWORD _radix);

;these are conversion routines for converting between the various classes found in BIAsm64

externdef BItoBD:near								;converts a ABI to ABD								CBD* BItoBD(CBI* _val);
externdef BItoBF:near								;converts a ABI to ABF								CBF* BItoBF(CBI* _val);
externdef BItoBDI:near								;converts a ABI to ABDI								CBDI* BItoBDI(CBI* _val);
externdef BItoBFI:near								;converts a ABI to ABFI								CBFI* BItoBFI(CBI* _val);
externdef BDtoBI:near								;converts a ABD to ABI								CBI* BDtoBI(CBD* _val);
externdef BDtoBF:near								;converts a ABD to ABF								CBF* BDtoBF(CBD* _val);
externdef BDtoBDI:near								;converts a ABD to ABDI								CBDI* BDtoBDI(CBD* _val);
externdef BDtoBFI:near								;converts a ABD to ABFI								CBFI* BDtoBFI(CBD* _val);
externdef BFtoBI:near								;converts a ABF to ABI								CBI* BFtoBI(CBF* _val);
externdef BFtoBD:near								;converts a ABF to ABD								CBD* BFtoBD(CBF* _val);
externdef BFtoBDI:near								;converts a ABF to ABDI								CBDI* BFtoBDI(CBF* _val);
externdef BFtoBFI:near								;converts a ABF to ABFI								CBFI* BFtoBFI(CBF* _val);
externdef BDItoBI:near								;converts a ABDI to ABI								CBI* BDItoBI(CBDI* _val);
externdef BDItoBD:near								;converts a ABDI to ABD								CBD* BDItoBD(CBDI* _val);
externdef BDItoBF:near								;converts a ABDI to ABF								CBF* BDItoBF(CBDI* _val);
externdef BDItoBFI:near								;converts a ABDI to ABFI								CBFI* BDItoBFI(CBDI* _val);
externdef BFItoBI:near								;converts a ABFI to ABI								CBI* BFItoBI(CBFI* _val);
externdef BFItoBD:near								;converts a ABFI to ABD								CBD* BFItoBD(CBFI* _val);
externdef BFItoBF:near								;converts a ABFI to ABF								CBF* BFItoBF(CBFI* _val);
externdef BFItoBDI:near								;converts a ABFI to ABDI								CBDI* BFItoBDI(CBFI* _val);

externdef ExceptionFilter:near

extrn malloc: PROC
extrn free: PROC
extrn GetLastError	:	PROC

;the ABI struct is the assembly implementation of the native c++ CBI class (which itself is used to form the managed c++ ABI class)

ABI				struct

	_sign				qword		0
	_num				qword		0

ABI				ends

;the ABD struct is the assembly implementation of the native c++ CBD class (which itself is used to form the managed c++ ABD class)

ABD				struct

	_sign				qword		0
	_decimalplace		qword		0
	_num				qword		0
	_adj				qword		0

ABD				ends

;the ABF struct is the assembly implementation of the native c++ CBF class (which itself is used to form the managed c++ ABF class)

ABF				struct

	_sign				qword		0
	_numerator			qword		0
	_denominator		qword		0

ABF				ends

;the ABDI struct is the assembly implementation of the native c++ CBDI class (which itself is used to form the managed c++ ABDI class)

ABDI			struct

	_polarform			qword		0
	_real				qword		0
	_im					qword		0

ABDI			ends

;the ABFI struct is the assembly implementation of the native c++ CBFI class (which itself is used to form the managed c++ ABFI class)

ABFI			struct

	_polarform			qword		0
	_real				qword		0
	_im					qword		0

ABFI			ends

;the BEGCD struct is the return value for the Binary Extended GCD alg

ABEGCD			struct

	_a					qword		0
	_b					qword		0
	_gtimesv			qword		0

ABEGCD			ends
